> ## Documentation Index
> Fetch the complete documentation index at: https://docs.kibocommerce.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Multi Rates

> Get List of Rate Responses for a List of Rate Requests



## OpenAPI

````yaml /openapi/openapi_shipping_storefront.json post /commerce/catalog/storefront/shipping/request-multi-rates
openapi: 3.0.1
info:
  description: OpenAPI Spec for Kibo ShippingRuntime Service
  title: Shipping Storefront
  version: 0.0.1
servers:
  - description: Kibo Base URL
    url: '{baseUrl}/api'
    variables:
      baseUrl:
        default: https://t1000000.sb.usc1.gcp.kibocommerce.com
        description: Base URL
security:
  - bearerAuth: []
paths:
  /commerce/catalog/storefront/shipping/request-multi-rates:
    post:
      tags:
        - Shipping
      summary: Get Multi Rates
      description: Get List of Rate Responses for a List of Rate Requests
      parameters:
        - description: ''
          in: query
          name: includeRawResponse
          schema:
            default: false
            type: boolean
        - description: limits which fields are returned in the response body
          in: query
          name: responseFields
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              items:
                $ref: '#/components/schemas/RateRequestGroup'
              type: array
        description: ''
      responses:
        '200':
          content:
            application/json:
              schema:
                items:
                  $ref: '#/components/schemas/RatesResponseGroup'
                type: array
            text/json:
              schema:
                items:
                  $ref: '#/components/schemas/RatesResponseGroup'
                type: array
            text/plain:
              schema:
                items:
                  $ref: '#/components/schemas/RatesResponseGroup'
                type: array
          description: OK
components:
  schemas:
    RateRequestGroup:
      properties:
        id:
          nullable: true
          type: string
        rateRequests:
          items:
            $ref: '#/components/schemas/RateRequest'
          nullable: true
          type: array
      type: object
    RatesResponseGroup:
      properties:
        componentRates:
          items:
            $ref: '#/components/schemas/RatesResponse'
          nullable: true
          type: array
        id:
          nullable: true
          type: string
        ratesResponse:
          $ref: '#/components/schemas/RatesResponse'
      type: object
    RateRequest:
      properties:
        attributes:
          description: Order Attributes. Made available for Arc.js to use
          items:
            $ref: '#/components/schemas/RateRequestAttribute'
          nullable: true
          type: array
        carrierIds:
          description: >-
            Optional.  If one or more Carrier Ids are specified then only the
            rates for the specified carrier('s/s') configured service types or
            shipping methods will be calculated resulting in better performance.
          items:
            type: string
          nullable: true
          type: array
        customAttributes:
          deprecated: true
          items:
            $ref: '#/components/schemas/CustomAttribute'
          nullable: true
          type: array
        data:
          nullable: true
          type: object
        destinationAddress:
          $ref: '#/components/schemas/CommerceRuntimeAddress'
        estimatedShipmentDate:
          description: >-
            Estimate Date/Time when the shipment for this will be sent. 
            Primarily utilize to estimate delivery date.
          format: date-time
          nullable: true
          type: string
        handlingTotal:
          description: >-
            The order Handling total after discounts to be used in rate
            calculation
          format: double
          nullable: true
          type: number
        id:
          nullable: true
          type: string
        isDestinationAddressCommercial:
          description: Is the destination address a commercial address?
          nullable: true
          type: boolean
        isoCurrencyCode:
          nullable: true
          type: string
        items:
          items:
            $ref: '#/components/schemas/RateRequestItem'
          nullable: true
          type: array
        orderDiscountedSubTotal:
          description: The Order SubTotal After Discounts to be used in rate calculation
          format: double
          nullable: true
          type: number
        orderTotal:
          description: The OrderTotal to be used in rate calculation
          format: double
          nullable: true
          type: number
        originAddress:
          $ref: '#/components/schemas/CommerceRuntimeAddress'
        originLocationCode:
          description: >-
            Optional for STH rates. The location code of the origin location.
            Used for calculation of Delivery rates.
          nullable: true
          type: string
        relatedOrderId:
          description: |-
            The Order ID to be used in rate calculation
            Informational only
          nullable: true
          type: string
        relatedOrderNumber:
          description: |-
            The Order Number to be used in rate calculation
            Informational only
          format: int32
          nullable: true
          type: integer
        shippingServiceTypes:
          description: >-
            Optional.  If one or more Shipping Service Type Codes are specified
            then only the specified rates for the specified carrier('s/s')
            configured service types or shipping methods will be calculated
            resulting in better performance.
          items:
            type: string
          nullable: true
          type: array
      type: object
    RatesResponse:
      properties:
        id:
          nullable: true
          type: string
        rates:
          items:
            $ref: '#/components/schemas/CarrierRatesResponse'
          nullable: true
          type: array
        resolvedShippingZoneCode:
          description: >-
            Resolved Shipping Zone Code.  This value can be null if the
            tenant/site does not have shipping zones defined or there are no
            matching 

            shipping zones for the request (e.g. the only zone defined is
            "UNITED-STATES" and the destination address of the rate request is
            in Canada)
          nullable: true
          type: string
        shippingZoneCodes:
          items:
            type: string
          nullable: true
          type: array
      type: object
    RateRequestAttribute:
      properties:
        attributeDefinitionId:
          format: int32
          nullable: true
          type: integer
        fullyQualifiedName:
          nullable: true
          type: string
        values:
          items: {}
          nullable: true
          type: array
      type: object
    CustomAttribute:
      properties:
        childAttributes:
          items:
            $ref: '#/components/schemas/CustomAttribute'
          nullable: true
          type: array
        key:
          nullable: true
          type: string
        value:
          nullable: true
          type: string
      type: object
    CommerceRuntimeAddress:
      properties:
        address1:
          nullable: true
          type: string
        address2:
          nullable: true
          type: string
        address3:
          nullable: true
          type: string
        address4:
          nullable: true
          type: string
        addressType:
          nullable: true
          type: string
        cityOrTown:
          nullable: true
          type: string
        countryCode:
          nullable: true
          type: string
        isValidated:
          nullable: true
          type: boolean
        postalOrZipCode:
          nullable: true
          type: string
        stateOrProvince:
          nullable: true
          type: string
      type: object
    RateRequestItem:
      description: Represents an item in a rate request, inheriting from RequestItem.
      properties:
        data:
          nullable: true
          type: object
        fulfillmentMethod:
          description: >-
            The fulfillment method on item to fetch rates for. Supported values
            are Ship and Delivery. Will assume Ship if nothing is passed.
          nullable: true
          type: string
        itemId:
          nullable: true
          type: string
        itemTotal:
          description: Item total.
          format: int32
          nullable: true
          type: integer
        productSummaries:
          description: >-
            If Product Summaries are populated, this information will be
            utilized in Product Rules (e.g. ProductCode eq "ABC" or (Weight.Unit
            eq "lbs" and Weight.Value ge 50)
          items:
            $ref: '#/components/schemas/ProductSummary'
          nullable: true
          type: array
        quantity:
          format: int32
          nullable: true
          type: integer
        shipsByItself:
          nullable: true
          type: boolean
        unitMeasurements:
          $ref: '#/components/schemas/ItemMeasurements'
      type: object
    CarrierRatesResponse:
      properties:
        carrierId:
          nullable: true
          type: string
        customAttributes:
          deprecated: true
          items:
            $ref: '#/components/schemas/CustomAttribute'
          nullable: true
          type: array
        fulfillmentMethod:
          description: >-
            The fulfillment method for which this carrier rate is applicable to.
            Possible values are Ship and Delivery.
          nullable: true
          type: string
        shippingRates:
          items:
            $ref: '#/components/schemas/ShippingRuntimeShippingRate'
          nullable: true
          type: array
      type: object
    ProductSummary:
      properties:
        categories:
          items:
            $ref: '#/components/schemas/ShippingRuntimeCategory'
          nullable: true
          type: array
        options:
          items:
            $ref: '#/components/schemas/ShippingRuntimeProductOption'
          nullable: true
          type: array
        price:
          description: Price (unit price * quantity)
          format: double
          type: number
        productCode:
          description: Merchant-created code that uniquely identifies the product.
          nullable: true
          type: string
        productDescription:
          description: Product name/description
          nullable: true
          type: string
        productType:
          nullable: true
          type: string
        properties:
          items:
            $ref: '#/components/schemas/ShippingRuntimeProductProperty'
          nullable: true
          type: array
        quantity:
          description: Product quantity
          format: int32
          type: integer
        unitMeasurements:
          $ref: '#/components/schemas/ItemMeasurements'
      type: object
    ItemMeasurements:
      properties:
        girth:
          description: Not exposed publicly
          format: double
          nullable: true
          type: number
        height:
          $ref: '#/components/schemas/CommerceRuntimeMeasurement'
        length:
          $ref: '#/components/schemas/CommerceRuntimeMeasurement'
        weight:
          $ref: '#/components/schemas/CommerceRuntimeMeasurement'
        width:
          $ref: '#/components/schemas/CommerceRuntimeMeasurement'
      type: object
    ShippingRuntimeShippingRate:
      properties:
        amount:
          format: double
          nullable: true
          type: number
        code:
          nullable: true
          type: string
        content:
          $ref: '#/components/schemas/ShippingRateLocalizedContent'
        customAttributes:
          items:
            $ref: '#/components/schemas/CustomAttribute'
          nullable: true
          type: array
        data:
          nullable: true
          type: object
        daysInTransit:
          format: int32
          nullable: true
          type: integer
        messages:
          items:
            $ref: '#/components/schemas/ShippingRateValidationMessage'
          nullable: true
          type: array
        shippingItemRates:
          items:
            $ref: '#/components/schemas/ShippingRuntimeShippingItemRate'
          nullable: true
          type: array
        windows:
          items:
            $ref: '#/components/schemas/ShippingRuntimeDeliveryWindow'
          nullable: true
          type: array
      type: object
    ShippingRuntimeCategory:
      description: Categories to which the product belongs.
      properties:
        id:
          format: int32
          type: integer
        parent:
          $ref: '#/components/schemas/ShippingRuntimeCategory'
      type: object
    ShippingRuntimeProductOption:
      properties:
        attributeFQN:
          nullable: true
          type: string
        dataType:
          nullable: true
          type: string
        value:
          nullable: true
      type: object
    ShippingRuntimeProductProperty:
      properties:
        attributeFQN:
          nullable: true
          type: string
        dataType:
          nullable: true
          type: string
        values:
          items: {}
          nullable: true
          type: array
      type: object
    CommerceRuntimeMeasurement:
      properties:
        unit:
          nullable: true
          type: string
        value:
          format: double
          nullable: true
          type: number
      type: object
    ShippingRateLocalizedContent:
      properties:
        localeCode:
          nullable: true
          type: string
        name:
          nullable: true
          type: string
      type: object
    ShippingRateValidationMessage:
      description: Shipping Rate Validation Message
      properties:
        helpLink:
          description: Help Link
          nullable: true
          type: string
        message:
          description: Message
          nullable: true
          type: string
        severity:
          description: Severity
          nullable: true
          type: string
      type: object
    ShippingRuntimeShippingItemRate:
      description: The shipping rate for a particular line item
      properties:
        amount:
          format: double
          nullable: true
          type: number
        itemId:
          nullable: true
          type: string
        quantity:
          format: int32
          nullable: true
          type: integer
      type: object
    ShippingRuntimeDeliveryWindow:
      properties:
        dropoffTime:
          $ref: '#/components/schemas/TimeWindow'
        pickupTime:
          $ref: '#/components/schemas/TimeWindow'
      type: object
    TimeWindow:
      description: Represents a time window with a start and end time.
      properties:
        endsAt:
          description: Gets or sets the end time of the time window.
          format: date-time
          nullable: true
          type: string
        startsAt:
          description: Gets or sets the start time of the time window.
          format: date-time
          type: string
      type: object
  securitySchemes:
    bearerAuth:
      bearerFormat: JWT
      description: JWT Authorization header using the Bearer scheme.
      scheme: bearer
      type: http

````